// 15bitJ[@R|WbgfMo̓vO@by K.Tanaka
// rfI CY7C1041DV33 (4Mbit,10ns)
// 240~224hbg
//@J[M120xƂɏo

// sڑ
// WE:PORTC1
// AD0-11:PORTD0-11
// AD12-17:PORTG0-3,6-7
// I/O 0-15:PORTB0-15

#include <p33FJ256GP506.h>
#include "sramvideo.h"

#define VRAMH 2 // VRAM̈ 0x20000-0x2ffff
#define WRAMH 3 // g`̈ 0x30000-0x3ffff

#define INVERTER // o͂ɃCo[^[͂łꍇÂ悤ɒ`Ă

//J[Mo̓f[^
//
#ifndef INVERTER

// 5bit DAAXg[go͂̏ꍇ
#define C_SYN	0
#define C_BLK	7
asm(".equ	C_SYN,0"); //x
asm(".equ	C_BLK,7"); //x
asm(".equ	C_BST1,7"); //J[o[XgMi0xj
asm(".equ	C_BST2,4"); //J[o[XgMi90xj
asm(".equ	C_BST3,7"); //J[o[XgMi180xj
asm(".equ	C_BST4,10"); //J[o[XgMi270xj
//@Xg[go͗pf[^܂

#else

// 5bit DAACo[^[o͂̏ꍇ

#define C_SYN	31
#define C_BLK	24
asm(".equ	C_SYN,31");
asm(".equ	C_BLK,24");
asm(".equ	C_BST1,24");
asm(".equ	C_BST2,27");
asm(".equ	C_BST3,24");
asm(".equ	C_BST4,21");

//@Co[^[o͗pf[^܂

#endif

// pX萔
#define V_NTSC		262					// 262{/
#define V_SYNC		10					// {
#define V_PREEQ		18					// uLOԏ㑤
#define V_LINE		Y_RES				// 摜`
#define H_NTSC		2724				// 63.5sec
#define H_SYNC		202					// A4.7sec
#define H_CBST		228					// J[o[XgJnʒui肩j
#define H_BACK		242					// Xy[Xiオ肩j

// O[oϐ`
unsigned int VRAMpH,VRAMpL; //VRAMAhXi2rbgA16rbgj
volatile unsigned int LineCount;// ̍s
volatile int drawing;		//@fԏ-1Ȃ0
volatile int drawcount;		//@1ʕ\IƂ1BAv0ɂB
							// Œ1͉ʕ\Ƃ̃`FbNƁAAv̏ʊԕKv̊mFɗpB


void sramwrite(unsigned int adh,unsigned int adl,unsigned int d)
{
	// SRAM̎wAhX1[h
	// adh:AD17-AD16 W0WX^Ɋi[
	// adl:AD15-AD0  W1WX^Ɋi[
	// d:݃f[^   W2WX^Ɋi[

	asm("PUSH	W3");
	asm("MOV.W	#0x0fff,W3");
	asm("AND.W	W1,W3,W3");
	asm("SL.W	W0,#6,W0");
	asm("LSR.W	W1,#12,W1");
	asm("ADD.W	W0,W1,W0");
	asm("DISI	#8");      //ȉ8ߒ̊荞݂֎~
	asm("MOV.W	W3,LATD"); //LATD=adl&0xfff;
	asm("MOV.W	W0,LATG"); //LATG=(adh<<6)+(adl>>12);
	asm("MOV.W	W2,LATB"); //LATB=d;
	asm("CLR.W	TRISB");   //PORTBo͂ɐݒ
	asm("BCLR.W	LATC,#1"); //WE[qLɐݒ
	asm("POP	W3");
	asm("BSET.W	LATC,#1"); //WE[qHɐݒ
	asm("SETM.W	TRISB");   //PORTB͂ɖ߂
}

unsigned int sramread(unsigned int adh,unsigned int adl)
{
	// SRAM̎wAhXǂݏo
	// adh:AD17-AD16@@W0WX^Ɋi[
	// adl:AD15-AD0@@ W1WX^Ɋi[
	// ߂l:ǂݏo16rbgf[^@W0WX^ŕԂ

	asm("PUSH	W2");
	asm("MOV.W	#0x0fff,W2");
	asm("AND.W	W1,W2,W2");
	asm("SL.W	W0,#6,W0");
	asm("LSR.W	W1,#12,W1");
	asm("ADD.W	W0,W1,W0");
	asm("DISI	#5");      //ȉ5ߒ̊荞݂֎~
	asm("MOV.W	W2,LATD"); //LATD=adl&0xfff;
	asm("MOV.W	W0,LATG"); //LATG=(adh<<6)+(adl>>12);
		//ǂݏo܂2߃NbÑEFCgKv
	asm("SETM.W	TRISB");   //PORTB͂ɐݒ
	asm("POP	W2");
	asm("MOV.W	PORTB,W0");//PORTBǂݏoA߂lƂ
}

void pset(unsigned int x,unsigned int y,unsigned int c)
{
	// W(x,y)ɃJ[c̓_`
	// J[cR:5,G:6,B:5rbg`iG5rbĝݗLj
	unsigned int ad,d1,d2,d;
	ad=((c&0x07c0)<<5)+((c&0xf800)>>5)+((c&0x001f)<<1);
	d1=sramread(WRAMH,ad);
	d2=sramread(WRAMH,ad+1);
	switch(x&3){
		case 0:
			d=(d1&0x1f)+((d1&0x1f00)>>3)+((d2&0x1f)<<10);
			break;
		case 1:
			d=((d2&0x1f00)>>8)+((d1&0x1f)<<5)+((d1&0x1f00)<<2);
			break;
		case 2:
			d=(d2&0x1f)+((d2&0x1f00)>>3)+((d1&0x1f)<<10);
			break;
		default:
			d=((d1&0x1f00)>>8)+((d2&0x1f)<<5)+((d2&0x1f00)<<2);
	}
	ad=(y<<8)+x;
	sramwrite(VRAMH,ad,d);
}

/**********************
*  Timer2 荞ݏ֐
***********************/
void __attribute__((interrupt,__no_auto_psv__, __shadow__)) _T2Interrupt(void)
{
	//1CJnBM

	//^C~Ô΂^C}[lǂݍ݂ŏC
	asm("MOV.W	TMR2,W1");
	asm("SUBR.W	W1,#20,W1");
	asm("MOV.W	RCOUNT,W0");
	asm("REPEAT	W1");
	asm("NOP");
	asm("MOV.W	W0,RCOUNT");
	//܂

	asm("MOV.B	#C_SYN,W0");
	asm("MOV.W	#LATF,W1");
	asm("MOV.B	W0,[W1]");		// MBɑSĂ̐Mo͂̃^C~O𒲐
	
	if(LineCount<V_SYNC){
		// 
		IEC0bits.T3IE = 0;		// ^C}3荞ݖi`J[o[Xgj
		IEC1bits.T5IE = 0;		// ^C}5荞ݖifMj
		IFS1bits.T4IF = 0;		// ^C}4荞݃tONA
		IEC1bits.T4IE = 1;		// ^C}4荞ݗLij
	}
	else{
		IFS0bits.T3IF = 0;		// ^C}3荞݃tONA
		IEC0bits.T3IE = 1;		// ^C}3荞ݗLi`J[o[Xgj
		IEC1bits.T4IE = 0;		// ^C}4荞ݖij
		if(LineCount>=V_SYNC+V_PREEQ && LineCount<V_SYNC+V_PREEQ+V_LINE){
			// 摜`
			IFS1bits.T5IF = 0;		// ^C}5荞݃tONA
			IEC1bits.T5IE = 1;		// ^C}5荞ݗLifMj
		}
		else{
			IEC1bits.T5IE = 0;		// ^C}5荞ݖifMj
		}
	}
	LineCount++;
	if(LineCount>=V_NTSC) LineCount=0;
	IFS0bits.T2IF = 0;			// T2荞݃tONA
}

/*********************
*  T4荞ݏ֐
*********************/
void __attribute__((interrupt,no_auto_psv, shadow)) _T4Interrupt(void)
{
	// M̃Zbg

	//^C~Ô΂^C}[lǂݍ݂ŏC
	asm("MOV.W	TMR4,W1");
	asm("SUBR.W	W1,#20,W1");
	asm("MOV.W	RCOUNT,W0");
	asm("REPEAT	W1");
	asm("NOP");
	asm("MOV.W	W0,RCOUNT");
	//܂

	asm("MOV.W	#LATF,W1");
	asm("MOV.B	#C_BLK,W0");
	asm("MOV.B	W0,[W1]");			// MZbgB肩2552TCN
	IFS1bits.T4IF = 0;				// T4荞݃tONA
}

/*********************
*  T3荞ݏ֐
*********************/
void __attribute__((interrupt,no_auto_psv, shadow)) _T3Interrupt(void)
{
	// M̃Zbg`J[o[XgMo

	//^C~Ô΂^C}[lǂݍ݂ŏC
	asm("MOV.W	TMR3,W1");
	asm("SUBR.W	W1,#20,W1");
	asm("MOV.W	RCOUNT,W0");
	asm("REPEAT	W1");
	asm("NOP");
	asm("MOV.W	W0,RCOUNT");
	//܂

	asm("MOV.W	#LATF,W1");
	asm("MOV.B	#C_BLK,W0");
	asm("MOV.B	W0,[W1]");			// MZbgB肩202TCN

	asm("NOP");asm("NOP");asm("NOP");asm("NOP");asm("NOP");
	asm("NOP");asm("NOP");asm("NOP");asm("NOP");asm("NOP");
	asm("NOP");asm("NOP");asm("NOP");asm("NOP");asm("NOP");
	asm("NOP");asm("NOP");asm("NOP");asm("NOP");asm("NOP");
	asm("NOP");asm("NOP");asm("NOP");asm("NOP");

	// J[o[XgM 9o
	asm("MOV.B	#C_BST1,W0");
	asm("MOV.B	W0,[W1]");			// J[o[XgJnB肩228TCN

	asm("NOP");	asm("MOV	#C_BST2,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST3,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST4,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST1,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST2,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST3,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST4,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST1,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST2,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST3,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST4,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST1,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST2,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST3,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST4,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST1,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST2,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST3,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST4,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST1,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST2,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST3,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST4,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST1,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST2,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST3,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST4,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST1,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST2,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST3,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST4,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST1,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST2,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST3,W0");	asm("MOV.B	W0,[W1]");
	asm("NOP");	asm("MOV	#C_BST4,W0");	asm("MOV.B	W0,[W1]");

	asm("NOP");	asm("MOV	#C_BLK,W0");	asm("MOV.B	W0,[W1]");
	IFS0bits.T3IF = 0;				// T3荞݃tONA
}


/***********************
*  T5荞ݏ֐
***********************/
void __attribute__((interrupt,no_auto_psv, shadow)) _T5Interrupt(void)
{
// fMo

	//^C~Ô΂^C}[lǂݍ݂ŏC
	asm("MOV.W	TMR5,W1");
	asm("SUBR.W	W1,#20,W1");
	asm("MOV.W	RCOUNT,W0");
	asm("REPEAT	W1");
	asm("NOP");
	asm("MOV.W	W0,RCOUNT");
	//܂

	asm("MOV.W	#0xffff,W0");
	asm("MOV.W	W0,_drawing"); //drawing=-1;
	asm("MOV.W	_VRAMpL,W0"); //\rfIAhX
	asm("MOV.W	_VRAMpH,W1");
	asm("LSR.W	W0,#12,W2");
	asm("SL.W	W1,#6,W1");
	asm("ADD.W	W1,W2,W1");
	asm("MOV.W	#LATG,W2");
	asm("MOV.B	W1,[W2]"); //AD12-17o
	asm("MOV.W	W0,LATD"); //AD0-11o

	// 萔ݒ
	asm("MOV.W	#LATF,W1");

	// [vJE^ݒ
	asm("MOV.W	#120,W0"); //2hbgMó~120񃋁[v

	// 240hbgǂݏoƏo͂𑱂
	asm("MOV.W	PORTB,W2"); //SRAM3񕪂̔g`f[^ǂݏo
	asm("INC.W	LATD"); //ǂݏoAhXXV
asm("LOOP1:");
	asm("MOV.B	W2,[W1]"); //fg`f[^o͊JnB肩444TCN
	asm("LSR.W	W2,#5,W2"); //5rbgVtg2ԖڐM𓾂
				asm("MOV.W	PORTB,W3"); //EFCgɁA3񕪂̔g`f[^ǂݏo
	asm("MOV.B	W2,[W1]"); //2Ԗڔg`f[^o
	asm("LSR.W	W2,#5,W2"); //5rbgVtg3ԖڐM𓾂
				asm("INC.W	LATD"); //EFCgɁAǂݏoAhXXV
	asm("MOV.B	W2,[W1]"); //3Ԗڔg`f[^o
	asm("NOP");
	asm("MOV.W	PORTB,W2"); //3񕪂̔g`f[^ǂݏo
				asm("MOV.B	W3,[W1]"); //2hbgڂ̏o͊Jn
				asm("LSR.W	W3,#5,W3");
	asm("INC.W	LATD");
				asm("MOV.B	W3,[W1]");
				asm("LSR.W	W3,#5,W3");
				asm("DEC.W	W0,W0"); //[vJE^
				asm("MOV.B	W3,[W1]");

	asm("BRA	NZ,LOOP1");

	asm("MOV.B	#C_BLK,W2");
	asm("MOV.B	W2,[W1]");

	VRAMpL+=256;
	if(LineCount==V_SYNC+V_PREEQ+V_LINE){ // 1ʍŌ̕`I
		drawing=0;
		drawcount++;
		VRAMpL=0;
	}

	IFS1bits.T5IF = 0;				// T5荞݃tONA
}

// ʃNA
void clearscreen(void)
{
	unsigned int ad;
	ad=0;
	do{
		sramwrite(VRAMH,ad,(C_BLK<<10)+(C_BLK<<5)+C_BLK);
		ad++;
	} while(ad!=0);
}

void wraminit(void)
{
// g`f[^
// J[ԍ0`32767ɑg`90xƂɌvZA4oCgŋL^
// 5rbgDAAd3.3V

	int y,y2,ry,by,s0,s1,s2,s3;
	int r,g,b;
	unsigned int ad;

	ad=0;
	for(g=0;g<32;g++){
		for(r=0;r<32;r++){
			for(b=0;b<32;b++){
				y=(150*g+29*b+77*r+128)/256;
				y2=441*y+180*32+512;
				ry=387*(r-y);
				by=217*(b-y);

				s0=(y2+ry)/795;
				s1=(y2+by)/795;
				s2=(y2-ry)/795;
				s3=(y2-by)/795;

// ȑODARo[^igpRl120`2.4Kjł͂L
/*
				s0=(y2+ry)/1024;
				s1=(y2+by)/1024;
				s2=(y2-ry)/1024;
				s3=(y2-by)/1024;
*/

#ifdef INVERTER
				s0^=0x1f;
				s1^=0x1f;
				s2^=0x1f;
				s3^=0x1f;
#endif
				sramwrite(WRAMH,ad,(s1<<8)+s0);
				sramwrite(WRAMH,ad+1,(s3<<8)+s2);
				ad+=2;
			}
		}
	}
}
void start_composite(void)
{
	// ϐݒ
	LineCount=0;			// CJE^[
	drawing=0;
	VRAMpH=VRAMH;
	VRAMpL=0;

	IFS0bits.T2IF = 0;		// 荞݃tONA
	IEC0bits.T2IE = 1;		// ^C}2荞ݗL
}
void stop_composite(void)
{
	// ^C}荞ݖŕ\~
	IEC0bits.T2IE = 0;
	IEC0bits.T3IE = 0;
	IEC1bits.T4IE = 0;
	IEC1bits.T5IE = 0;
}

// J[R|Wbgo͏
void init_composite(void)
{
	// e^C}̏ݒASēNbN63.5usec
	// 荞݃x5
	T2CON = 0x0000;
	PR2 = H_NTSC-1;
	IPC1bits.T2IP = 5;
	IEC0bits.T2IE = 0;

	T3CON = 0x0000;
	PR3 = H_NTSC-1;
	IPC2bits.T3IP = 5;
	IEC0bits.T3IE = 0;

	T4CON = 0x0000;
	PR4 = H_NTSC-1;
	IPC6bits.T4IP = 5;
	IEC1bits.T4IE = 0;

	T5CON = 0x0000;
	PR5 = H_NTSC-1;
	IPC7bits.T5IP = 5;
	IEC1bits.T5IE = 0;

	wraminit();
	clearscreen();

	TMR2 = H_NTSC-100;
	TMR3 = H_NTSC-100-H_SYNC+1;
	TMR4 = H_SYNC-100+2;
	TMR5 = H_NTSC-100-H_SYNC-H_BACK+15;

	T2CONbits.TON = 1;	// ^C}2X^[g
	T3CONbits.TON = 1;	// ^C}3X^[g
	T4CONbits.TON = 1;	// ^C}4X^[g
	T5CONbits.TON = 1;	// ^C}5X^[g

	start_composite();	// f֘AϐA^C}2荞ݗL
}
